window.MultipleChoiceTestData = {
    // Optional: Wie viele Versuche hat der/die Lernende (Standardwert: Unendlich)
    "maxTries": Infinity,

    // Optional: Soll statt der Anzahl an nötigen Versuchen bewertet werden, wie gut der/die Lernende abschneidet?
    "reportScore": false,

    // Optional: Sollen die Fragen nicht durchgemischt werden?
    "keepOrder": false,

    // Optional: Wie soll bewertet werden?
    // "questions"  → Standardwert, Frage kann entweder richtig sein (1 von 1 Punkt) oder falsch (0 von 1 Punkt)
    // "average"    → Durchschnittlicher Prozentsatz an richtig ausgewählten bzw. richtig nicht ausgewählten Antwortmöglichkeiten pro auswählbaren Antwortmöglichkeiten bei jeder Frage
    // "choices"    → Anteil der richtig ausgewählten Antwortmöglichkeiten pro auswählbaren Antwortmöglichkeiten
    "countMode": "questions",

    // Wie viele Fragen sollen für einen Test gezogen werden?
    "questionsPerTest": 6,

    // Welcher Anteil muss mindestens richtig sein, um zu bestehen?
    "threshold": 1,

    // Optional: Begrüßungstext
    "htmlIntro": "<p>Gib alle Nullstellenanzahlen richtig an, um dieses Lernpaket erfolgreich abzuschließen.</p>",

    // Verfügbare Fragen
    "questions": [],

    // Fragengeneratoren
    "generators": []
};

(function(generators) {
    function addFrage(arrFragen, a, x_S, y_S) {
        if (Math.random() < 0.75)
            a *= (1 + Math.floor(Math.random() * 9));
        x_S *= (1 + Math.floor(Math.random() * 9));
        y_S *= (1 + Math.floor(Math.random() * 9));
        const vorher = (Math.abs(a) == 1) ? ((a < 0) ? '-' : '') : (a + " ");
        const frage = {
            "html": "???",
            "keepOrder": true,
            "choices": [
                { "html": "Nullstellenanzahl: ", "min": 0, "max": 9, "step": 1, "type": "number", "size": 2, "correct": true, "accept": -1, "response": "" }
            ]
        };
        let term = vorher;
        term += (x_S ? (((Math.sign(x_S) == -1) ? '(x + ' : '(x - ') + Math.abs(x_S) + ')²') : "x²");
        if (y_S)
            term += ((Math.sign(y_S) == -1) ? ' - ' : ' + ') + Math.abs(y_S);
        frage.html = "<p>Wie viele Nullstellen hat <code>f(x) = " + term + "</code>?</p>";
        frage.choices[0].response = "<code>f(x) = " + term + " = <strong style=\"background-color:#fce94f\">" + a + "</strong> · ";
        frage.choices[0].response += (x_S < 0) ? '[x - (' : '(x - ';
        frage.choices[0].response += "<strong style=\"background-color:#fce94f\">" + x_S + "</strong>";
        frage.choices[0].response += (x_S < 0) ? ')]' : ')';
        frage.choices[0].response += '² + ';
        frage.choices[0].response += (y_S < 0) ? '(' : '';
        frage.choices[0].response += "<strong style=\"background-color:#fce94f\">" + y_S + "</strong>";
        frage.choices[0].response += (y_S < 0) ? ')' : '';
        frage.choices[0].response += '</code>, darum Scheitel <code>(' + x_S + ' | ' + y_S + ')<code> und nach ' + ((a > 0) ? 'oben' : 'unten') + ' geöffnete Parabel.';
        switch (true) {
            case (y_S == 0):
                frage.choices[0].accept = 1;
                frage.choices[0].response += ' Weil Scheitel auf x-Achse liegt, gibt es nur eine Nullstelle, nämlich <code>' + x_S + '</code>.';
                break;
            case (Math.sign(a) == Math.sign(y_S)):
                frage.choices[0].accept = 0;
                frage.choices[0].response += ' Somit kann die Parabel die x-Achse nicht schneiden, weil die komplette Parabel ' + ((a > 0) ? 'über' : 'unter') + ' der x-Achse liegt.';
                break;
            default:
                frage.choices[0].accept = 2;
                frage.choices[0].response += ' Somit muss die Parabel die x-Achse zweimal schneiden.';
                break;
        }
        arrFragen.push(frage);
    }

    [-1, 0, +1].map(y_S => [-1, 0, +1].map(x_S => [-1, +1].map(a => generators.push(arrFragen => addFrage(arrFragen, a, x_S,  y_S)))));
})(window.MultipleChoiceTestData.generators);
